/********************************************************************************
 *   objdump -- ROM modules dumper for Windows CE                               *
 *                                                                              * 
 *   Copyright (C) 2004-2007 dci (dev@cpp.in)                                   *
 *                                                                              *
 *   This program is free software; you can redistribute it and/or              *
 *   modify it under the terms of the GNU General Public License version 2      *
 *   as published by the Free Software Foundation.                              *
 *                                                                              *
 *   This program is distributed in the hope that it will be useful,            *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
 *   General Public License version 2 for more details.                         *
 *                                                                              *
 *   You should have received a copy of the GNU General Public License          *
 *   version 2 along with this program; if not, write to the Free Software      *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 ********************************************************************************
 */

#include <windows.h>

#include <pkfuncs.h>
#include <psyscall.h>
#include <kernel.h>

#define ALIGNUP(val,by) ( ( ( val ) % ( by ) ) ? ( ( val ) + ( by )  - ( ( val ) % ( by ) ) ) : ( val ) )
#define ALIGNDN(val,by) ( ( ( val ) % ( by ) ) ? ( ( val ) - ( ( val ) % ( by ) ) ) : ( val ) )


unsigned char doshdr [ ] =
{
	0x4D, 0x5A, 0x90, 0x00, 0x03, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00,
	0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x00,
	0x0E, 0x1F, 0xBA, 0x0E, 0x00, 0xB4, 0x09, 0xCD, 0x21, 0xB8, 0x01, 0x4C, 0xCD, 0x21, 0x54, 0x68,
	0x69, 0x73, 0x20, 0x70, 0x72, 0x6F, 0x67, 0x72, 0x61, 0x6D, 0x20, 0x63, 0x61, 0x6E, 0x6E, 0x6F,
	0x74, 0x20, 0x62, 0x65, 0x20, 0x72, 0x75, 0x6E, 0x20, 0x69, 0x6E, 0x20, 0x44, 0x4F, 0x53, 0x20,
	0x6D, 0x6F, 0x64, 0x65, 0x2E, 0x0D, 0x0D, 0x0A, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};




/* intervals merger, result saved in int1* values */
void ic_intmerge ( DWORD * int1b, DWORD * int1s, DWORD int2b, DWORD int2s )
{
	/* merge beginning */
	if ( * int1b )
	{
		if ( int2b < ( * int1b ) )
		{
			( * int1s ) += ( ( * int1b ) - int2b );
			( * int1b ) = int2b;
		}
	}
	else
	{
		( * int1b ) = int2b;
		( * int1s ) = int2s;
	}
	/* merge ending */
	if ( ( ( * int1b ) + ( * int1s ) ) < ( int2b + int2s ) )
	{
		( * int1s ) = ( int2b + int2s ) - ( * int1b );
	}
}



BOOL ic_Dump ( wchar_t * lib )
{
	MODULE * mod = ( MODULE * ) LoadLibraryEx ( lib, NULL, LOAD_LIBRARY_AS_DATAFILE );




	/* */
	int i;
	DWORD imgoff = sizeof ( doshdr );
	/* alloc headers */
	IMAGE_NT_HEADERS * nthdr = ( IMAGE_NT_HEADERS * ) malloc ( sizeof ( IMAGE_NT_HEADERS ) );
	IMAGE_SECTION_HEADER * sechdrs = ( IMAGE_SECTION_HEADER * ) malloc ( mod->e32.e32_objcnt * sizeof ( IMAGE_SECTION_HEADER ) );
	memset ( nthdr, 0, sizeof ( IMAGE_NT_HEADERS ) );
	memset ( sechdrs, 0, mod->e32.e32_objcnt * sizeof ( IMAGE_SECTION_HEADER ) );
	/* fill pe header */
	nthdr->Signature = IMAGE_NT_SIGNATURE;
	nthdr->FileHeader.Machine = IMAGE_FILE_MACHINE_ARM; /* todo: or thumb? :-) */
	nthdr->FileHeader.NumberOfSections = mod->e32.e32_objcnt;
	nthdr->FileHeader.TimeDateStamp = 0; /* todo: some sane value here */
	nthdr->FileHeader.PointerToSymbolTable = 0;
	nthdr->FileHeader.NumberOfSymbols = 0;
	nthdr->FileHeader.SizeOfOptionalHeader = IMAGE_SIZEOF_NT_OPTIONAL32_HEADER;
	nthdr->FileHeader.Characteristics = /* todo: is it DLL? */ /* IMAGE_FILE_DLL |*/ IMAGE_FILE_EXECUTABLE_IMAGE | IMAGE_FILE_32BIT_MACHINE;
	nthdr->OptionalHeader.Magic = IMAGE_NT_OPTIONAL_HDR32_MAGIC;
	nthdr->OptionalHeader.MajorLinkerVersion = 6;
	nthdr->OptionalHeader.MinorLinkerVersion = 0;
	nthdr->OptionalHeader.SizeOfCode = 0; /* will be calced later */
	nthdr->OptionalHeader.SizeOfInitializedData = 0; /* will be calced later */
	nthdr->OptionalHeader.SizeOfUninitializedData = 0; /* will be calced later */
	nthdr->OptionalHeader.AddressOfEntryPoint = ( ( char * ) mod->startip ) - ( ( char * ) mod->BasePtr );
	nthdr->OptionalHeader.BaseOfCode = 0; /* will be calced later */
	nthdr->OptionalHeader.BaseOfData = 0; /* will be calced later */
	nthdr->OptionalHeader.ImageBase = mod->e32.e32_vbase;
	nthdr->OptionalHeader.SectionAlignment = 0x40000000; /* 0x1000 in common case, maximum value here to trace down later. */
	nthdr->OptionalHeader.FileAlignment = 0x200; /* ce likes this */
	nthdr->OptionalHeader.MajorOperatingSystemVersion = mod->e32.e32_cevermajor;
	nthdr->OptionalHeader.MinorOperatingSystemVersion = 0;
	nthdr->OptionalHeader.MajorImageVersion = 0;
	nthdr->OptionalHeader.MinorImageVersion = 0;
	nthdr->OptionalHeader.MajorSubsystemVersion = mod->e32.e32_cevermajor;
	nthdr->OptionalHeader.MinorSubsystemVersion = mod->e32.e32_ceverminor;
	nthdr->OptionalHeader.Win32VersionValue = 0;
	nthdr->OptionalHeader.SizeOfImage = mod->e32.e32_vsize;
	nthdr->OptionalHeader.SizeOfHeaders = 0; /* 0x400 in common case, to be calced later */
	nthdr->OptionalHeader.CheckSum = 0;
	nthdr->OptionalHeader.Subsystem = IMAGE_SUBSYSTEM_WINDOWS_CE_GUI;
	nthdr->OptionalHeader.DllCharacteristics = 0;
	nthdr->OptionalHeader.SizeOfStackReserve = 0x00100000; /* mod->e32.e32_stackmax; */
	nthdr->OptionalHeader.SizeOfStackCommit = 0x1000;
	nthdr->OptionalHeader.SizeOfHeapReserve = 0x00100000;
	nthdr->OptionalHeader.SizeOfHeapCommit = 0x1000;
	nthdr->OptionalHeader.LoaderFlags = 0;
	nthdr->OptionalHeader.NumberOfRvaAndSizes = IMAGE_NUMBEROF_DIRECTORY_ENTRIES;
	/* fill data dirs */
	for ( i = 0; i < LITE_EXTRA; ++i )
	{
		nthdr->OptionalHeader.DataDirectory [ i ].VirtualAddress = mod->e32.e32_unit [ i ].rva;
		nthdr->OptionalHeader.DataDirectory [ i ].Size = mod->e32.e32_unit [ i ].size;
	}
	/* move img offset */
	imgoff += sizeof ( IMAGE_NT_HEADERS );
	/* fill common data in sections hdrs & section-related in pe header */
	for ( i = 0; i < mod->e32.e32_objcnt; ++i )
	{
		DWORD chars = mod->o32_ptr [ i ].o32_flags;
		DWORD vbase = mod->o32_ptr [ i ].o32_rva;
		DWORD vsize = mod->o32_ptr [ i ].o32_vsize;
		/* trace down section align value */
		while ( ( mod->o32_ptr [ i ].o32_rva ) % nthdr->OptionalHeader.SectionAlignment ) nthdr->OptionalHeader.SectionAlignment = nthdr->OptionalHeader.SectionAlignment / 2;
		/* try to determine what section is this */
		if ( chars & IMAGE_SCN_CNT_CODE )
		{
			ic_intmerge ( &nthdr->OptionalHeader.BaseOfCode, &nthdr->OptionalHeader.SizeOfCode, vbase, vsize );
			strncpy ( sechdrs [ i ].Name, ".text", IMAGE_SIZEOF_SHORT_NAME );
		}
		else
		{
			if ( chars & IMAGE_SCN_CNT_INITIALIZED_DATA )
			{
				ic_intmerge ( &nthdr->OptionalHeader.BaseOfData, &nthdr->OptionalHeader.SizeOfInitializedData, vbase, vsize );
			}
			_snprintf ( sechdrs [ i ].Name, IMAGE_SIZEOF_SHORT_NAME, ".dci%d", i );
		}
		/* */
		sechdrs [ i ].Misc.VirtualSize = vsize;
		sechdrs [ i ].VirtualAddress = vbase;
		sechdrs [ i ].SizeOfRawData = ( chars & IMAGE_SCN_CNT_UNINITIALIZED_DATA ) ? 0 : ALIGNUP ( vsize, nthdr->OptionalHeader.FileAlignment ); /* todo: move analysis to switch above */
		sechdrs [ i ].PointerToRawData = 0; /* fill later */
		sechdrs [ i ].PointerToRelocations = 0; /* not used in ce */
		sechdrs [ i ].PointerToLinenumbers = 0;
		sechdrs [ i ].NumberOfRelocations = 0; /* not used in ce */
		sechdrs [ i ].NumberOfLinenumbers = 0;
		sechdrs [ i ].Characteristics = chars;
		/* move img offset */
		imgoff += sizeof ( IMAGE_SECTION_HEADER );
	}
	/* align img offset, update pe header fields */
	imgoff = ALIGNUP ( imgoff, nthdr->OptionalHeader.FileAlignment );
	nthdr->OptionalHeader.SizeOfHeaders = imgoff;
	nthdr->OptionalHeader.SizeOfCode = ALIGNUP ( nthdr->OptionalHeader.SizeOfCode, nthdr->OptionalHeader.FileAlignment );
	nthdr->OptionalHeader.SizeOfInitializedData = ALIGNUP ( nthdr->OptionalHeader.SizeOfInitializedData, nthdr->OptionalHeader.FileAlignment );
	/* now position sections in file */
	for ( i = 0; i < nthdr->FileHeader.NumberOfSections; ++i )
	{
		if ( sechdrs [ i ].SizeOfRawData )
		{
			sechdrs [ i ].PointerToRawData = imgoff;
			imgoff += sechdrs [ i ].SizeOfRawData;
		}
	}
	/* finally it's time to write */
	if ( 1 )
	{
		FILE * f = fopen ( "\\testout.dll", "w+b" );
		/* headers */
		fwrite ( doshdr, 1, sizeof ( doshdr ), f );
		fwrite ( nthdr, 1, sizeof ( IMAGE_NT_HEADERS ), f );
		fwrite ( sechdrs, 1, nthdr->FileHeader.NumberOfSections * sizeof ( IMAGE_SECTION_HEADER ), f );
		/* data */
		for ( i = 0; i < nthdr->FileHeader.NumberOfSections; ++i )
		{
			fseek ( f, sechdrs [ i ].PointerToRawData, SEEK_SET );
			if ( sechdrs [ i ].SizeOfRawData )
			{
				fwrite ( ( ( char * ) mod->BasePtr ) + sechdrs [ i ].VirtualAddress, 1, sechdrs [ i ].Misc.VirtualSize, f );
				//fwrite ( ( ( char * ) mod->e32.e32_vbase ) + sechdrs [ i ].VirtualAddress, 1, sechdrs [ i ].Misc.VirtualSize, f );
				fseek ( f, sechdrs [ i ].PointerToRawData + sechdrs [ i ].SizeOfRawData, SEEK_SET );
			}
		}
		/* force align in much weird way */
		fseek ( f, - ( long ) sizeof ( i ), SEEK_CUR );
		if ( fread ( &i, 1, sizeof ( i ), f ) )
		{
			fseek ( f, - ( long ) sizeof ( i ), SEEK_CUR );
		}
		else
		{
			i = 0;
		}
		fwrite ( &i, 1, sizeof ( i ), f );
		/* finish */
		fflush ( f );
		fclose ( f );
	}
	/* free headers */
	free ( sechdrs );
	free ( nthdr );
		











	/* debug info about module */
	printf ( "BasePtr: %08X, ep: %08X, objects: %d\n", mod->BasePtr, mod->startip, mod->e32.e32_objcnt );
	printf ( "ver %d.%02d\n", mod->e32.e32_cevermajor, mod->e32.e32_ceverminor );
	printf ( "vbase %08X, vsize %08X\n", mod->e32.e32_vbase, mod->e32.e32_vsize );
	printf ( "s14rva %08X, s14size %08X\n", mod->e32.e32_sect14rva, mod->e32.e32_sect14size );

	for ( i = 0; i < mod->e32.e32_objcnt; ++i )
	{
		printf ( "obj[%d].vsize %08X\n", i, mod->o32_ptr [ i ].o32_vsize );
		printf ( "obj[%d].rva %08X\n", i, mod->o32_ptr [ i ].o32_rva );
		printf ( "obj[%d].realaddr %08X\n", i, mod->o32_ptr [ i ].o32_realaddr );
		printf ( "obj[%d].access %08X\n", i, mod->o32_ptr [ i ].o32_access );
		printf ( "obj[%d].flags %08X\n", i, mod->o32_ptr [ i ].o32_flags );
		printf ( "obj[%d].dataptr %08X\n", i, mod->o32_ptr [ i ].o32_dataptr );
	}

	FreeLibrary ( ( HMODULE ) mod );
	return 1;
}

int WinMain ( HINSTANCE hInst, HINSTANCE hPrevInst, LPWSTR lpCmdLine, int nShowCmd )
{
//	SetKMode ( 1 );
//	SetProcPermissions ( 0xFFFFFFFF );

//	ic_Dump ( L"\\libtest.dll" );
	ic_Dump ( L"nk.exe" );

	MessageBox ( NULL, L"stop", NULL, MB_TOPMOST );
	return 0;
}
